library reflector.test.mirrors_test;

import 'package:guinness/guinness.dart';
import 'package:matcher/matcher.dart' hide expect;
import 'package:reflector/reflector.dart';
import 'package:reflector/mirrors.dart';

void main() {
  describe('MirrorsReflector', () {
    MirrorsReflector reflector;

    it('returns metadata for each class', () {
      reflector = new MirrorsReflector.fromClasses(const [B, C]);
      expect(reflector()).to(hasLength(2));
    });

    it('enforces `withAnnotations`', () {
      reflector = new MirrorsReflector.fromClasses(const [A, B]);

      final metadata = reflector(const Query(withAnnotations: const [C]));
      expect(metadata).to(hasLength(1));
      expect(metadata.first.type).toEqual(A);
    });

    it('enforces `includeAnnotations`', () {
      reflector = new MirrorsReflector.fromClasses(const [A]);
      expect(reflector().first.annotations).toEqual([const C()]);
      expect(
          reflector(const Query(includeAnnotations: false)).first.annotations)
          .to(isEmpty);
    });
  });
}

// Test data.

@C()
class A {}

class B {}

class C {
  const C();
}
